/*********************************************************************************
Disclaimer:
----------------------
LICENSE:
    SpritED is licensed under the GPL (http://www.gnu.org/licenses/gpl.txt)
    For further details concerning usage, modification and distribution issues,
    check the  GNU website or check the verbatim copy of the license included with this
    package.

WARRANTY:
    SpritED is provided WITHOUT ANY KIND OF WARRANTY. Damnsoft development team
    or any member of it have no responsibility about any damage made
    to you, or your computer and/or peripherals after/while/before using this
    program. Damnsoft is not guilty if your computer explodes, disappears and/or
    starts talking to you or otherwise your dog leaves home, your daughter's
    boyfriend gets involved on a crime, your wife is arrested, your boss
    reduce your salary payment or any event on your -or mankind- lifetime.

    Elias Zacarias.                       Copyleft (C) 2003 - 2004 Damnsoft
**********************************************************************************
** EXAMPLE.C: Dummy Filter Example.                                             **
**********************************************************************************/
#include "..\filterlib.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/********************************************************************
 **  getname: Stores the filter's name on a char buffer.           **
 ********************************************************************/
void _stdcall getname(char *buff){
	strcpy(buff,"Dummy Filter Example v0.1");
}


/********************************************************************
 **  config: Defines the filter configuration and stores it on a   **
 **           given config_api structure.                          **
 ********************************************************************/
void _stdcall config(struct sprite_nfo *si, struct config_api *conf){
	struct list_type plist;

	add_spara(conf, "Randomness","0");
	add_spara(conf, "Level","21");

	list_init(&plist,"Color",2);
		add_listop(&plist,"White");
		add_listop(&plist,"Light Gray");
		add_listop(&plist,"Dark Gray");
		add_listop(&plist,"Black");
	add_lpara(conf, plist);
}


/********************************************************************
 **  filter: Applies the Filter to a sprite stream. Options are    **
 **          passed on a config_api structure.                     **
 ********************************************************************/
short int _stdcall filter(char *s, struct sprite_nfo *si, struct config_api conf){
	char buff[17];
	int selcolor;
	int randomness;
	int level;
	char msgbuff[64];

	get_string(&conf, 0, buff);
	randomness = atoi(buff);

	get_string(&conf, 1, buff);
	level = atoi(buff);

	selcolor = get_selected(&conf, 0);

	/* Build a string with some information to display */
	sprintf(msgbuff,"w:%d h:%d random:%d level:%d selcolor:%d",si->w,si->h,randomness,level,selcolor);

	/* Show a box with the message built above */
	MessageBox(NULL, msgbuff, "Filter example", MB_OK);

	/* Plot a pixel :P */
	plotpx(s, si, 0, 4,2, 1);
	return 1;
}
